function animation2(t,z,R,writeMovie, delay, nameMovie)

phi = linspace(0,2*pi);
x_circle = R*cos(phi);
y_circle = R*sin(phi);

if (writeMovie)
    mov = VideoWriter(nameMovie); 
    open(mov);
end

n = length(t);
for i = 1:n
              
        theta=z(i,3); 
        x_robot = z(i,1) + x_circle;
        y_robot = z(i,2) + y_circle;
        x_dir = z(i,1) + [0 R*cos(theta)];
        y_dir = z(i,2) + [0 R*sin(theta)];

         
         plot(z(1:i,1),z(1:i,2),'r','Linewidth',2); hold on;
         light_blue = [176,224,230]/255; %from https://www.rapidtables.com/web/color/blue-color.html
         h1= patch(x_robot,y_robot,light_blue);  
         h2 = line(x_dir,y_dir,'Color','black','Linewidth',2);
           
          axis('equal');
          span = max([-min(min(z(:,1:2))) max(max(z(:,1:2)))]);
          span = max([span 2]);
          axis([-span span -span span]);
          grid on;

           pause(delay)
           delete(h1);
           delete(h2);
           
           if (writeMovie)
            axis off %does not show axis
            set(gcf,'Color',[1,1,1]) %set background to white
            writeVideo(mov,getframe);
           end
           
end % end for loop

if (writeMovie)
    close(mov);
end


